--- a/drivers/tty/serial/8250/8250.c	2012-04-13 18:42:02.000000000 +0200
+++ b/drivers/tty/serial/8250/8250.c	2012-04-14 12:52:38.988685431 +0200
@@ -2798,7 +2798,11 @@
 	struct uart_8250_port *up =
 		container_of(port, struct uart_8250_port, port);
 
+#ifdef CONFIG_AR7
+	wait_for_xmitr(up, BOTH_EMPTY);
+#else
 	wait_for_xmitr(up, UART_LSR_THRE);
+#endif
 	serial_out(up, UART_TX, ch);
 }
 
